typedef struct {int x, y; } t_ponto;

#define MAX_PONTOS 3000
t_ponto p[MAX_PONTOS];
int quant_pontos = 0;

/* ----------------------------------------------------------------------- */

void SequenciaDePontosDaReta(int x0, int y0, int x1, int y1) {

/* Determina os pontos da reta (x0, y0) - (x1, y1) usando o algoritmo de
   Bresenham. Os pontos sao guardados na matriz de pontos global p[]. */

  int aux, primeiro_octante, dx, dy, incrE, incrNE,
      X0, X1, Y0, Y1, d, x, y, inclinacao_negativa;

  if (x0 > x1) {
    aux = x0; x0 = x1; x1 = aux;
    aux = y0; y0 = y1; y1 = aux;
  }

  X0 = x0; X1= x1; Y0 = y0; Y1 = y1;

  inclinacao_negativa = (y0 > y1);
  if (inclinacao_negativa) {
    aux = y0; y0 = y1; y1 = aux;
  }

  primeiro_octante = (y1 - y0 <= x1 - x0);
  if (!primeiro_octante) {
    aux = x0; x0 = y0; y0 = aux;
    aux = x1; x1 = y1; y1 = aux;
  }

  dx = x1 - x0;
  dy = y1 - y0;
  d = 2*dy - dx;
  incrE = 2*dy;
  incrNE = 2*(dy - dx);
  x = x0;
  y = y0;

  if (primeiro_octante)
    if (inclinacao_negativa)
      { p[quant_pontos].x = x; p[quant_pontos].y = Y0 + Y1 - y; }
    else
      { p[quant_pontos].x = x; p[quant_pontos].y = y; }
  else
    if (inclinacao_negativa)
      { p[quant_pontos].x = X0 + X1 - y; p[quant_pontos].y = x; }
    else
      { p[quant_pontos].x = y; p[quant_pontos].y = x; }
  quant_pontos++;

  while (x < x1) {

    if (d < 0) {
      d = d + incrE;
      x = x + 1;
    } else {
      d = d + incrNE;
      x = x + 1;
      y = y + 1;
    }

    if (primeiro_octante)
      if (inclinacao_negativa)
	{ p[quant_pontos].x = x; p[quant_pontos].y = Y0 + Y1 - y; }
      else
	{ p[quant_pontos].x = x; p[quant_pontos].y = y; }
    else
      if (inclinacao_negativa)
	{ p[quant_pontos].x = X0 + X1 - y; p[quant_pontos].y = x; }
      else
	{ p[quant_pontos].x = y; p[quant_pontos].y = x; }
    quant_pontos++;
  }
}

/* ----------------------------------------------------------------------- */

void Preenche(int cor, int cor_secundaria, int padrao) {

/* Preenche a regiao delitada pela matriz de pontos p[]. Sao usadas duas
   cores de preenchimento misturadas segundo o padrao de bits indicado. */

  int teste, cont = 0, i, a0, b0, a1, b1, m, M, linha, col;

  a0 = 10000; a1 = -10000;
  b0 = 10000; b1 = -10000;
  for (i = 0; i < quant_pontos; i++) {
   if (a0 > p[i].x) a0 = p[i].x;
   if (b0 > p[i].y) b0 = p[i].y;
   if (a1 < p[i].x) a1 = p[i].x;
   if (b1 < p[i].y) b1 = p[i].y;
  }

  for (linha = b0; linha <= b1; linha++) {
    m = 10000; M = -10000;
    for (i = 0; i < quant_pontos; i++)
      if (linha == p[i].y) {
	if (m > p[i].x) m = p[i].x;
	if (M < p[i].x) M = p[i].x;
      }
    for (col = m; col <= M; col++) {
      cont++;
      cont %= 8;
      teste = padrao >> cont;
      if (teste & 1)
	putpixel(col, linha, cor);
      else
	putpixel(col, linha, cor_secundaria);
    }
  }
}

/* ----------------------------------------------------------------------- */

void DeterminaPontos(int a, int b, int c, int d, int e, int f) {

  quant_pontos = 0;
  SequenciaDePontosDaReta(a, b, c, d);
  SequenciaDePontosDaReta(c, d, e, f);
  SequenciaDePontosDaReta(a, b, e, f);
  if (quant_pontos > MAX_PONTOS) return;
}

/* ----------------------------------------------------------------------- */

void Pintar(int a, int b, int c, int d, int e, int f,
	    int cor_front, int cor_int1, int cor_int2, int padrao) {

/* Pinta a regiao (a, b) - (c, d) - (e, f). A fronteira e' pintada
   com  a cor cor_front. O interior  e' pintado  com  as cores  cor_int1  e
   cor_int2 misturadas conforme os bits do parametro padrao. */

  DeterminaPontos(a, b, c, d, e, f);
  Preenche(cor_int1, cor_int2, padrao);
  setcolor(cor_front);
  line(a, b, c, d);
  line(c, d, e, f);
  line(e, f, a, b);
}

/* ----------------------------------------------------------------------- */
